import java.util.Random;

public class Elf implements Runnable {

	enum ElfState {
		WORKING, TROUBLE, AT_SANTAS_DOOR
	};

	private ElfState state;
	/**
	 * The number associated with the Elf
	 */
	private int number;
	private Random rand = new Random();
	private SantaScenario scenario;
	
	public Elf(int number, SantaScenario scenario) {
		this.number = number;
		this.scenario = scenario;
		this.state = ElfState.WORKING;
	}
	
	
	public ElfState getState() {
		return state;
	}

	/**
	 * Santa might call this function to fix the trouble
	 * @param state
	 */
	public void setState(ElfState state) {
		this.state = state;
	}


	@Override
	public void run() {
		// ** Moved the sleep into the while loop		
		while (true) {
			// wait a day
			try {
				Thread.sleep(100);
			} catch (InterruptedException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			switch (state) {
			case WORKING: {
				// at each day, there is a 1% chance that an elf runs into
				// trouble.
				if (rand.nextDouble() < 0.01) {
					state = ElfState.TROUBLE;
				}
				break;
			}
			case TROUBLE:
				// FIXME: if possible, move to Santa's door
				break;
			case AT_SANTAS_DOOR:
				// FIXME: if feasible, wake up Santa
				break;
			}
		}
	}
	
	/**
	 * Report about my state in the HTML format
	 */
	public String toHtml() {
		String temp = "<b>Elf " + number + " </b>: ";
		switch(state) {
		case WORKING:
			temp += "<span color=green> WORKING </span>";
			break;
		case TROUBLE:
			temp += "<span color=red> TROUBLE </span>";
			break;
		case AT_SANTAS_DOOR:
			temp += "<span color=blue> AT_SANTAS_DOOR </span>";
			break;			
		}
		temp += "<br/>";
		return temp;
	}

}
